# MAYBE TODO: default codecs (aom, libde265, x265, jpeg) as plugins, package plugins in subpackages?
# TODO: uvg266 vvdec>=2.3.0 vvenc>=1.12.0 openjph
#
# Conditional build:
%bcond_with	golang		# Go examples
%bcond_without	static_libs	# static library
%bcond_with	tests		# testing
# AVIF
%bcond_without	aom		# aom AVIF decoder/encoder
%bcond_with	dav1d		# dav1d AVIF decoder
%bcond_with	svtav1		# SVT-AV1 AVIF encoder
%bcond_with	rav1e		# rav1e AVIF encoder
# HEVC
%bcond_with	ffmpeg		# FFmpeg HEVC decoder (hw accelerated)
%bcond_with	kvazaar		# kvazaar HEVC encoder
%bcond_without	libde265	# libde265 HEVC decoder
%bcond_without	x265		# x265 HEVC encoder
# JPEG
%bcond_without	jpeg		# JPEG codecs support
# JPEG-2000
%bcond_without	openjpeg	# OpenJPEG (J2K) codecs support

%ifnarch %{ix86} %{x8664} aarch64
%undefine	with_rav1e
%endif
Summary:	ISO/IEC 23008-12:2017 HEIF file format decoder and encoder
Summary(pl.UTF-8):	Koder i dekoder formatu plików HEIF zgodnego z ISO/IEC 23008-12:2017
Name:		libheif
Version:	1.18.2
Release:	1
License:	LGPL v3+ (library), GPL v3+ (tools)
Group:		Libraries
#Source0Download: https://github.com/strukturag/libheif/releases/
Source0:	https://github.com/strukturag/libheif/releases/download/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	5446af621e88be0edc9373c22c198007
URL:		https://github.com/strukturag/libheif
%{?with_aom:BuildRequires:	aom-devel}
BuildRequires:	cmake >= 3.16.3
%{?with_dav1d:BuildRequires:	dav1d-devel}
# libavcodec
%{?with_ffmpeg:BuildRequires:	ffmpeg-devel}
BuildRequires:	gdk-pixbuf2-devel >= 2.0
%{?with_golang:BuildRequires:	golang >= 1.6}
%{?with_kvazaar:BuildRequires:	kvazaar-devel}
%{?with_libde265:BuildRequires:	libde265-devel >= 1.0.7}
%{?with_jpeg:BuildRequires:	libjpeg-devel}
BuildRequires:	libpng-devel
BuildRequires:	libsharpyuv-devel
BuildRequires:	libstdc++-devel >= 6:4.7
%{?with_x265:BuildRequires:	libx265-devel}
%{?with_openjpeg:BuildRequires:	openjpeg2-devel >= 2}
BuildRequires:	pkgconfig
%{?with_rav1e:BuildRequires:	rav1e-devel}
%{?with_svtav1:BuildRequires:	svt-av1-devel}
BuildRequires:	rpmbuild(macros) >= 1.734
%{?with_libde265:Requires:	libde265 >= 1.0.7}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
libheif is an ISO/IEC 23008-12:2017 HEIF file format decoder and
encoder.

HEIF is a new image file format employing HEVC (h.265) image coding
for the best compression ratios currently possible.

libheif makes use of libde265 for the actual image decoding and x265
for encoding. Alternative codecs for, e.g., AVC and JPEG can be
provided as plugins.

%description -l pl.UTF-8
libheif to koder i dekoder formatu plików HEIF, zgodnego z ISO/IEC
23008-12:2017.

HEIF to nowy format plików obrazów wykorzystujący kodowanie obrazu
HEVC (h.265) w celu osiągnięcia najwyższych dostepnych obecnie
współczynników kompresji.

libheif wykorzystuje libde265 do właściwego procesu dekodowania obrazu
oraz x265 do kodowania. Alternatywne kodeki do np. AVC czy JPEG mogą
być dostarczone jako wtyczki.

%package devel
Summary:	Header files for libheif
Summary(de.UTF-8):	libheif Headers
Summary(pl.UTF-8):	Pliki nagłówkowe libheif
License:	LGPL v3+
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
%{?with_aom:Requires:	aom-devel}
Requires:	libde265-devel >= 1.0.7
Requires:	libsharpyuv-devel
Requires:	libstdc++-devel >= 6:4.7
Requires:	libx265-devel

%description devel
The header files are only needed for development of programs using the
libheif library.

%description devel -l pl.UTF-8
Pliki nagłówkowe, potrzebne jedynie do rozwijania oprogramowania
wykorzystującego bibliotekę libheif.

%package static
Summary:	Static libheif library
Summary(pl.UTF-8):	Statyczna biblioteka libheif
License:	LGPL v3+
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static libheif library.

%description static -l pl.UTF-8
Statyczna biblioteka libheif.

%package progs
Summary:	libheif utility programs
Summary(pl.UTF-8):	Programy narzędziowe libheif
License:	GPL v3+
Group:		Applications/Graphics
Requires:	%{name} = %{version}-%{release}

%description progs
This package contains utility programs to convert HEIF files.

%description progs -l pl.UTF-8
Ten pakiet zawiera programy narzędziowe do konwersji plików HEIF.

%package -n gdk-pixbuf2-loader-heif
Summary:	gdk-pixbuf plugin to handle HEIF files
Summary(pl.UTF-8):	Wtyczka gdk-pixbuf do obsługi plików HEIF
Group:		Libraries
Requires:	%{name} = %{version}-%{release}

%description -n gdk-pixbuf2-loader-heif
gdk-pixbuf plugin to handle HEIF files.

%description -n gdk-pixbuf2-loader-heif -l pl.UTF-8
Wtyczka gdk-pixbuf do obsługi plików HEIF.

%prep
%setup -q

%build
%if %{with static_libs}
%cmake -B build-static \
	-DBUILD_SHARED_LIBS=OFF \
	-DENABLE_PLUGIN_LOADING=OFF \
	%{!?with_aom:-DWITH_AOM_DECODER=OFF} \
	%{!?with_aom:-DWITH_AOM_ENCODER=OFF} \
	%{?with_dav1d:-DWITH_DAV1D=ON} \
	%{?with_ffmpeg:-DWITH_FFMPEG_DECODER=ON} \
	%{?with_jpeg:-DWITH_JPEG_DECODER=ON} \
	%{?with_jpeg:-DWITH_JPEG_ENCODER=ON} \
	%{?with_kvazaar:-DWITH_KVAZAAR=ON} \
	%{!?with_libde265:-DWITH_LIBDE265=OFF} \
	%{?with_openjpeg:-DWITH_OpenJPEG_DECODER=ON} \
	%{?with_openjpeg:-DWITH_OpenJPEG_ENCODER=ON} \
	%{?with_rav1e:-DWITH_RAV1E=ON} \
	%{?with_svtav1:-DWITH_SvtEnc=ON} \
	%{!?with_x265:-DWITH_X265=OFF}

%{__make} -C build-static
%endif

%cmake -B build \
	%{?with_tests:-DBUILD_TESTING=ON} \
	%{!?with_aom:-DWITH_AOM_DECODER=OFF} \
	%{!?with_aom:-DWITH_AOM_ENCODER=OFF} \
	%{?with_dav1d:-DWITH_DAV1D=ON} \
	%{?with_ffmpeg:-DWITH_FFMPEG_DECODER=ON} \
	%{?with_ffmpeg:-DWITH_FFMPEG_DECODER_PLUGIN=ON} \
	%{?with_jpeg:-DWITH_JPEG_DECODER=ON} \
	%{?with_jpeg:-DWITH_JPEG_ENCODER=ON} \
	%{?with_kvazaar:-DWITH_KVAZAAR=ON} \
	%{?with_kvazaar:-DWITH_KVAZAAR_PLUGIN=ON} \
	%{!?with_libde265:-DWITH_LIBDE265=OFF} \
	%{?with_openjpeg:-DWITH_OpenJPEG_DECODER=ON} \
	%{?with_openjpeg:-DWITH_OpenJPEG_ENCODER=ON} \
	%{?with_rav1e:-DWITH_RAV1E=ON} \
	%{?with_svtav1:-DWITH_SvtEnc=ON} \
	%{!?with_x265:-DWITH_X265=OFF}

%{__make} -C build

%{?with_tests:%{__make} -C build check}

%install
rm -rf $RPM_BUILD_ROOT

%if %{with static_libs}
%{__make} -C build-static install \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc README.md
%attr(755,root,root) %{_libdir}/libheif.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libheif.so.1
%dir %{_libdir}/libheif
# TODO: subpackages with plugins?
%if %{with dav1d}
%attr(755,root,root) %{_libdir}/libheif/libheif-dav1d.so
%endif
%if %{with ffmpeg}
%attr(755,root,root) %{_libdir}/libheif/libheif-ffmpegdec.so
%endif
%if %{with openjpeg}
%attr(755,root,root) %{_libdir}/libheif/libheif-j2kdec.so
%attr(755,root,root) %{_libdir}/libheif/libheif-j2kenc.so
%endif
%if %{with kvazaar}
%attr(755,root,root) %{_libdir}/libheif/libheif-kvazaar.so
%endif
%if %{with rav1e}
%attr(755,root,root) %{_libdir}/libheif/libheif-rav1e.so
%endif
%if %{with svtav1}
%attr(755,root,root) %{_libdir}/libheif/libheif-svtenc.so
%endif

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libheif.so
%{_includedir}/libheif
%{_pkgconfigdir}/libheif.pc
%{_libdir}/cmake/libheif

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libheif.a
%endif

%files progs
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/heif-dec
%attr(755,root,root) %{_bindir}/heif-enc
%attr(755,root,root) %{_bindir}/heif-info
%attr(755,root,root) %{_bindir}/heif-thumbnailer
%{_datadir}/thumbnailers/heif.thumbnailer
%{_mandir}/man1/heif-dec.1*
%{_mandir}/man1/heif-enc.1*
%{_mandir}/man1/heif-info.1*
%{_mandir}/man1/heif-thumbnailer.1*

%files -n gdk-pixbuf2-loader-heif
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/gdk-pixbuf-2.0/2.*/loaders/libpixbufloader-heif.so
%changelog
* Sun Sep 15 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/libheif.git;a=log;h=master

* Sun Sep 15 2024 Jakub Bogusz <qboosh@pld-linux.org> 9fe33b3
- updated to 1.18.2; heif-convert has been renamed to heif-dec

* Sun May 26 2024 Jakub Bogusz <qboosh@pld-linux.org> c62a278
- updated to 1.17.6

* Sun Oct 22 2023 Jakub Bogusz <qboosh@pld-linux.org> 3f569d4
- updated to 1.17.1

* Mon Aug 21 2023 Jan Palus <atler@pld-linux.org> bdc31b8
- fix files without static_libs

* Mon Aug 21 2023 Jakub Bogusz <qboosh@pld-linux.org> 30b9fa8
- updated to 1.16.2; switched to cmake (autotools support is gone)

* Sun Mar 05 2023 Jakub Bogusz <qboosh@pld-linux.org> 9421cb5
- updated to 1.15.1

* Tue Aug 02 2022 Jan Palus <atler@pld-linux.org> c5f298c
- BR/R: libde265 >= 1.0.7; rel 3

* Sat Apr 02 2022 Jakub Bogusz <qboosh@pld-linux.org> f1d28cc
- release 2 (dav1d soname change)

* Mon Jun 28 2021 Jakub Bogusz <qboosh@pld-linux.org> 9e922b5
- updated to 1.12.0

* Sun Apr 25 2021 Jakub Bogusz <qboosh@pld-linux.org> 6b874e2
- disable rav1e where librav1e not available

* Sat Apr 24 2021 Jakub Bogusz <qboosh@pld-linux.org> 4d2cff7
- updated to 1.11.0
- removed obsolete pc patch

* Sat Oct 31 2020 Jakub Bogusz <qboosh@pld-linux.org> 25f2ac5
- updated to 1.9.1

* Fri Sep 25 2020 Jakub Bogusz <qboosh@pld-linux.org> 9ecd4f4
- updated to 1.9.0

* Mon Mar 09 2020 Jakub Bogusz <qboosh@pld-linux.org> 582b558
- updated to 1.6.2
- updated gdk-pixbuf patch

* Sat Nov 02 2019 Jan Rękorajski <baggins@pld-linux.org> 73036a4
- disable go code on x32
- rel 3

* Tue Oct 29 2019 Jakub Bogusz <qboosh@pld-linux.org> 097d4e5
- release 2 (rebuild with libx265 3.2)

* Sat Oct 26 2019 Jakub Bogusz <qboosh@pld-linux.org> 17ed322
- updated to 1.5.1 (includes fix for CVE-2019-11471)

* Wed Aug 07 2019 Jakub Bogusz <qboosh@pld-linux.org> a94ea98
- release 2 (libde265 and libx265 soname change)

* Sun Jun 16 2019 Jakub Bogusz <qboosh@pld-linux.org> 21ff4bc
- updated to 1.4.0
- added gdkpixbuf patch (drop version from gdk-pixbuf loader module), added gdk-pixbuf2-loader-heif package

* Fri Mar 15 2019 Jan Palus <atler@pld-linux.org> 773ffd0
- release 4 (by relup.sh)

